/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	v2alpha1 "github.com/kyverno/kyverno/api/kyverno/v2alpha1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakePolicyExceptions implements PolicyExceptionInterface
type FakePolicyExceptions struct {
	Fake *FakeKyvernoV2alpha1
	ns   string
}

var policyexceptionsResource = schema.GroupVersionResource{Group: "kyverno.io", Version: "v2alpha1", Resource: "policyexceptions"}

var policyexceptionsKind = schema.GroupVersionKind{Group: "kyverno.io", Version: "v2alpha1", Kind: "PolicyException"}

// Get takes name of the policyException, and returns the corresponding policyException object, and an error if there is any.
func (c *FakePolicyExceptions) Get(ctx context.Context, name string, options v1.GetOptions) (result *v2alpha1.PolicyException, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(policyexceptionsResource, c.ns, name), &v2alpha1.PolicyException{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2alpha1.PolicyException), err
}

// List takes label and field selectors, and returns the list of PolicyExceptions that match those selectors.
func (c *FakePolicyExceptions) List(ctx context.Context, opts v1.ListOptions) (result *v2alpha1.PolicyExceptionList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(policyexceptionsResource, policyexceptionsKind, c.ns, opts), &v2alpha1.PolicyExceptionList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &v2alpha1.PolicyExceptionList{ListMeta: obj.(*v2alpha1.PolicyExceptionList).ListMeta}
	for _, item := range obj.(*v2alpha1.PolicyExceptionList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested policyExceptions.
func (c *FakePolicyExceptions) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(policyexceptionsResource, c.ns, opts))

}

// Create takes the representation of a policyException and creates it.  Returns the server's representation of the policyException, and an error, if there is any.
func (c *FakePolicyExceptions) Create(ctx context.Context, policyException *v2alpha1.PolicyException, opts v1.CreateOptions) (result *v2alpha1.PolicyException, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(policyexceptionsResource, c.ns, policyException), &v2alpha1.PolicyException{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2alpha1.PolicyException), err
}

// Update takes the representation of a policyException and updates it. Returns the server's representation of the policyException, and an error, if there is any.
func (c *FakePolicyExceptions) Update(ctx context.Context, policyException *v2alpha1.PolicyException, opts v1.UpdateOptions) (result *v2alpha1.PolicyException, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(policyexceptionsResource, c.ns, policyException), &v2alpha1.PolicyException{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2alpha1.PolicyException), err
}

// Delete takes name of the policyException and deletes it. Returns an error if one occurs.
func (c *FakePolicyExceptions) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteActionWithOptions(policyexceptionsResource, c.ns, name, opts), &v2alpha1.PolicyException{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakePolicyExceptions) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(policyexceptionsResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &v2alpha1.PolicyExceptionList{})
	return err
}

// Patch applies the patch and returns the patched policyException.
func (c *FakePolicyExceptions) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *v2alpha1.PolicyException, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(policyexceptionsResource, c.ns, name, pt, data, subresources...), &v2alpha1.PolicyException{})

	if obj == nil {
		return nil, err
	}
	return obj.(*v2alpha1.PolicyException), err
}
