/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v2alpha1

import (
	v2alpha1 "github.com/kyverno/kyverno/api/kyverno/v2alpha1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// CleanupPolicyLister helps list CleanupPolicies.
// All objects returned here must be treated as read-only.
type CleanupPolicyLister interface {
	// List lists all CleanupPolicies in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v2alpha1.CleanupPolicy, err error)
	// CleanupPolicies returns an object that can list and get CleanupPolicies.
	CleanupPolicies(namespace string) CleanupPolicyNamespaceLister
	CleanupPolicyListerExpansion
}

// cleanupPolicyLister implements the CleanupPolicyLister interface.
type cleanupPolicyLister struct {
	indexer cache.Indexer
}

// NewCleanupPolicyLister returns a new CleanupPolicyLister.
func NewCleanupPolicyLister(indexer cache.Indexer) CleanupPolicyLister {
	return &cleanupPolicyLister{indexer: indexer}
}

// List lists all CleanupPolicies in the indexer.
func (s *cleanupPolicyLister) List(selector labels.Selector) (ret []*v2alpha1.CleanupPolicy, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v2alpha1.CleanupPolicy))
	})
	return ret, err
}

// CleanupPolicies returns an object that can list and get CleanupPolicies.
func (s *cleanupPolicyLister) CleanupPolicies(namespace string) CleanupPolicyNamespaceLister {
	return cleanupPolicyNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// CleanupPolicyNamespaceLister helps list and get CleanupPolicies.
// All objects returned here must be treated as read-only.
type CleanupPolicyNamespaceLister interface {
	// List lists all CleanupPolicies in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v2alpha1.CleanupPolicy, err error)
	// Get retrieves the CleanupPolicy from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v2alpha1.CleanupPolicy, error)
	CleanupPolicyNamespaceListerExpansion
}

// cleanupPolicyNamespaceLister implements the CleanupPolicyNamespaceLister
// interface.
type cleanupPolicyNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all CleanupPolicies in the indexer for a given namespace.
func (s cleanupPolicyNamespaceLister) List(selector labels.Selector) (ret []*v2alpha1.CleanupPolicy, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v2alpha1.CleanupPolicy))
	})
	return ret, err
}

// Get retrieves the CleanupPolicy from the indexer for a given namespace and name.
func (s cleanupPolicyNamespaceLister) Get(name string) (*v2alpha1.CleanupPolicy, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v2alpha1.Resource("cleanuppolicy"), name)
	}
	return obj.(*v2alpha1.CleanupPolicy), nil
}
